Bug 971960 - Evolution show in message another picture ...
Evolution show in message another picture ...
Product: Fedora
Classification: Fedora
Component: webkitgtk3 (Show other bugs)
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: Matthias Clasen
Fedora Extras Quality Assurance
Depends On:
  Show dependency treegraph
Reported: 2013-06-07 13:36 EDT by Mikhail
Modified: 2013-07-11 23:20 EDT (History)
9 users (show)

See Also:
Fixed In Version: webkitgtk3-2.0.3-2.fc19
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Last Closed: 2013-07-11 23:20:06 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---

Attachments (Terms of Use)
Outlook vs Evolution 3.6.4 (689.76 KB, image/png)
2013-06-07 13:36 EDT, Mikhail
no flags Details
Evolution 3.8.2 (500.45 KB, image/png)
2013-06-07 13:38 EDT, Mikhail
no flags Details
problem message (436.80 KB, application/mbox)
2013-06-07 13:38 EDT, Mikhail
no flags Details

  None (edit)
Description Mikhail 2013-06-07 13:36:57 EDT
Created attachment 758251 [details]
Outlook vs Evolution 3.6.4

Description of problem:
Evolution show in message another picture ...
Comment 1 Mikhail 2013-06-07 13:38:10 EDT
Created attachment 758253 [details]
Evolution 3.8.2
Comment 2 Mikhail 2013-06-07 13:38:48 EDT
Created attachment 758254 [details]
problem message
Comment 3 Mikhail 2013-06-07 13:45:14 EDT
Right picture displayed in evolution 3.8.2 as attachment with name 'attachment.dat' :(
Comment 4 Milan Crha 2013-06-10 05:39:24 EDT
Hmm, we were dealing with the same thing at bug #923060, did it regress? If I recall correctly, the sending software uses same image content identificators (CID) between different messages, like here it's "Image0". Evolution caches some data, like these images, and uses the CID to grab the right one, thus if user viewed one message with Iamge0 for the first time, then evolution showed the right image, but when moving to the next message with Image0, then there was shown image from the previous message, not from the actual. According to the upstream bug from bug #923060, this is supposed to be fixed since 3.8.1 of evolution.
Comment 5 Mikhail 2013-06-10 23:45:51 EDT
May be it's regress. Current version of evolution 3.8.3 and I have this issue :(

# rpm -q evolution
Comment 6 Milan Crha 2013-06-17 09:56:18 EDT
I finally got to this and after the first tests it seems to me that webkigtk3 regressed, and doesn't ignore the cache as it should.
Comment 7 Milan Crha 2013-06-17 10:21:42 EDT
Evolution uses there three functions to turn off caching in webkit:
> webkit_set_cache_model (WEBKIT_CACHE_MODEL_DOCUMENT_VIEWER);
> webkit_set_default_web_database_quota (0);
> webkit_application_cache_set_maximum_size (0);

which worked pre-webkit 2.0 (in time of bug #923060 on Fedora 18), but in Fedora 19, with webkitgtk3-2.0.3-1 this is not working, webkit picks the image from its cache. I added some debug prints to evolution and I see that the first request after start for "cid:Image0" is received by mail_display_resource_requested(), and transformed into mail:// url, which is caught by e-mail-request.c:handle_mail_request(), just as expected. When I choose the second message, which also has an image identified as "cid:Image0", the mail_display_resource_requested() is called, but not the handle_mail_request(), thus I believe the webkit skipped it, because it found "cid:Image0" in its cache, despite the transformed URLs are different.

According to WebKitCacheModel documentation:
> WEBKIT_CACHE_MODEL_DOCUMENT_VIEWER   Disable the cache completely, which
> substantially reduces memory usage. Useful for applications that only access
> a single local file, with no navigation to other pages. No remote resources
> will be cached.

from which I understand that there will be no caching at all. I verified that in time of the mail_display_resource_requested() is properly set WEBKIT_CACHE_MODEL_DOCUMENT_VIEWER cache model.

I'm moving this to webkitgtk3, for further investigation what could break.
Comment 8 Fedora Update System 2013-07-09 07:08:35 EDT
webkitgtk3-2.0.3-2.fc19 has been submitted as an update for Fedora 19.
Comment 9 Fedora Update System 2013-07-09 21:31:15 EDT
Package webkitgtk3-2.0.3-2.fc19:
* should fix your issue,
* was pushed to the Fedora 19 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing webkitgtk3-2.0.3-2.fc19'
as soon as you are able to.
Please go to the following url:
then log in and leave karma (feedback).
Comment 10 Fedora Update System 2013-07-11 23:20:06 EDT
webkitgtk3-2.0.3-2.fc19 has been pushed to the Fedora 19 stable repository.  If problems still persist, please make note of it in this bug report.

Note You need to log in before you can comment on or make changes to this bug.